Browse Source

Some options overhaul and 8fw json support

Signed-off-by: fbt <fbt@fleshless.org>
master
Jack L. Frost 6 years ago
parent
commit
7c9d85e8c0
  1. 96
      ufw

96
ufw

@ -28,17 +28,17 @@ usage() {
-d|--description # Supply a description.
-D|--screenshot-delay <num> # Delay the shot by <num> seconds.
-p|--public # Make the file public.
-u|--short # Generate a shortlink from URL.
-u|--shorten # Generate a shortlink from URL.
-S|--short-url # Get a shortlink when uploading a file.
-P|--page-url # Get a link to the file page instead of a direct one.
-m|--max-filesize # Maximum filesize (takes K, M and G suffixes).
-a|--album-id # Add the file to an album.
-A|--album-name # Add the file to an album by name. The album will be crated, if necessary.
-M|--api-format # API response format.
Config options (~/.config/ufw):
secret # Your personal token. Get it at https://zfh.so/settings_form
cfg_screenshot_ext # Screenshot file type, used by scrot.
cfg_max_filesize # Maximum filesize (takes K, M and G suffixes).
cfg_api_format # Set the api response format. Supports json or plain (default).
# Others are self-explanatory:
cfg_url_regex
cfg_tmp_dir
@ -115,40 +115,81 @@ upload() {
get_file_hash "$file"
if [[ "$album_name" ]]; then
if album_id=$( curl -fsL "$cfg_service_url/$cfg_api_path/album?a=new&name=$album_name&format=plain&secret=$secret" ); then
api_response=$( curl -fsL "$cfg_service_url/$cfg_api_path/album?a=new&name=$album_name&format=json&secret=$secret" )
read -r api_status api_status_message < <(
jshon -e status -e code -u -p -e message -u <<< "$api_response"
)
if (( api_status == 200 )); then
album_id=$( jshon -e data -e album -e id -u <<< "$api_response" )
misc_curl_args+=( -F album_id="$album_id" )
else
printf 'Error [album]: %s %s\n' "$api_status" "$api_status_message"
return 1
fi
fi
curl -sL \
api_response=$( curl -sL \
-F file="@$file" \
-F api_format="$cfg_api_format" \
-F api_format='json' \
-F flag_private="$flag_private" \
-F short="$flag_shortlink" \
-F secret="$secret" \
-F submit="" \
"${misc_curl_args[@]}" \
-A 'zerofiles.org upload script' \
"$cfg_service_url/$cfg_api_path/upload"
"$cfg_service_url/$cfg_api_path/upload" )
read -r api_status api_status_message < <(
jshon -e status -e code -u -p -e message -u <<< "$api_response"
)
if (( $? )); then
err 'Something has gone wrong with the upload.'
return 7
if (( flag_shortlink )); then
if (( flag_directlink )); then
file_url_request='short_url_direct'
else
file_url_request='short_url'
fi
else
if (( flag_directlink )); then
file_url_request='direct_url'
else
file_url_request='page_url'
fi
fi
if (( api_status == 200 )); then
file_link=$( jshon -e data -e file -e "$file_url_request" -u <<< "$api_response" )
printf '%s\n' "$file_link"
if (( flag_rm )); then
msg "Removing file: $file"
rm "$file"
fi
else
printf 'Error: %s %s\n' "$api_status" "$api_status_message"
return 1
fi
}
get_shortlink() {
declare url=$1
declare url=$1 api_response api_status api_status_message
api_response=$( curl -sL "$cfg_service_url/$cfg_api_path/url?a=add&url=${url}&format=json&secret=$secret" )
read -r api_status api_status_message < <(
jshon -e status -e code -u -p -e message -u <<< "$api_response"
)
if ! curl -fsL "$cfg_service_url/api?mode=url_add&url=${url}&raw=1"; then
err 'Something went wrong!'
if (( api_status == 200 )); then
read -r short_url real_url < <(
jshon -e data -e URL -e shorturl -u <<< "$api_response"
)
printf '%s\n' "$short_url"
else
printf 'Error: %s %s\n' "$api_status" "$api_status_message"
fi
}
@ -190,10 +231,19 @@ _mktemp() {
}
get_my_ip() {
my_ip=$( curl -fsL https://zfh.so/ip )
declare api_response api_status api_status_message my_ip
api_response=$( curl -sl "$cfg_service_url/$cfg_api_path/ip?format=json" )
if ! (( $? )); then
printf '%s\n' $my_ip
read -r api_status api_status_message < <(
jshon -e status -e code -u -p -e message -u <<< "$api_response"
)
if (( api_status == 200 )); then
my_ip=$( jshon -e data -e ip -u <<< "$api_response" )
printf '%s\n' "$my_ip"
else
printf 'Error: %s %s\n' "$api_status" "$api_status_message"
fi
}
@ -250,9 +300,11 @@ main() {
cfg_service_url='https://8fw.me'
cfg_screenshot_ext='png'
cfg_max_filesize='200M'
cfg_api_format='plain'
cfg_api_path='/api/2'
flag_shortlink=0
flag_directlink=1
if [[ -f "$HOME/.suprc" ]]; then
printf 'Found legacy configfile, moving...\n' >&2
mv "$HOME/.suprc" "$XDG_CONFIG_DIR/ufw"
@ -279,12 +331,12 @@ main() {
-m|--max-filesize) cfg_max_filesize=$2; shift;;
-M|--api-format) cfg_api_format=$2; shift;;
-i|--my-ip) action='getmyip';;
-S|--short) flag_shortlink='1';;
-u|--url) action='url';;
-u|--shorten) action='url';;
-S|--short-url) flag_shortlink=1;;
-P|--page-url) flag_directlink=0;;
-a|--album-id)
misc_curl_args+=( -F "album_id=$2" )

Loading…
Cancel
Save